/*
    FEARLUS model0-6-8+ELMM0-2: BuyDearestSelectionStrategy.m
    Copyright (C) 1999-2002  Macaulay Institute

    This file is part of FEARLUS model0-6-8+ELMM0-2, an agent-based model of land use
    change.

    FEARLUS model0-6-8+ELMM0-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-8+ELMM0-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*

    FEARLUS model0-6-8+ELMM0-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-8+ELMM0-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*

Implementation of the BuyDearestSelectionStrategy class.

*/

#import "BuyDearestSelectionStrategy.h"
#import "MiscFunc.h"
#import "Tuple.h"
#import "LandParcel.h"
#import "AssocArray.h"

@implementation BuyDearestSelectionStrategy

/* -selectBids:fromList:
 *
 * Select the cheapest bids first.
 */

-(void)selectBids: (AssocArray *)bids fromList: (id <List>)list {
  double total_spend = 0.0;
  id <List> bid_list;
  id <Index> ix;
  Tuple *bid;

  bid_list = [bids getValues];

  [MiscFunc shuffleList: bid_list];
  [MiscFunc mergeSort: bid_list withSelector: M(getDouble)];

  while([list getCount] > 0) {
    [list removeFirst];
  }

  for(ix = [bid_list begin: scratchZone], [ix setLoc: End], bid = [ix prev];
      [ix getLoc] == Member;
      bid = [ix prev]) {
    double price = [bid getDouble];
    LandParcel *lp = [bid getBeta];

    if(price + total_spend <= budget) {
      [list addLast: lp];
      total_spend += price;
    }
  }

  [ix drop];
}

@end
