/*
    FEARLUS model0-6-8+ELMM0-2: ParcelPriceReport.h
    Copyright (C) 1999-2002  Macaulay Institute

    This file is part of FEARLUS model0-6-8+ELMM0-2, an agent-based model of land use
    change.

    FEARLUS model0-6-8+ELMM0-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-8+ELMM0-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*

    FEARLUS model0-6-8+ELMM0-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-8+ELMM0-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*

This report spews out the most recent/average price paid for a land parcel,
in an arc grid style format. We'll see whether this can actually be read in
to arc info...

*/

#import <objectbase/SwarmObject.h>
#import "Report.h"


@class ModelSwarm, Parameter, AssocArray;

@interface ParcelPriceReport: SwarmObject <Report> {
  Parameter *parameter;
  ModelSwarm *model;
  id <List> fixedYears;
  id <List> repeatYears;
  BOOL average;
  double xllcorner;
  double yllcorner;
  double cellsize;
}

+(id <Report>)create: aZone;
-(void)setModelSwarm: (ModelSwarm *)m andParameters: (Parameter *)p;
-(void)reportForYear: (unsigned)year toFile: (FILE *)fp;
-(BOOL)setOption: (char *)option toValue: (char *)value;
-(BOOL)setOptionFlag: (char *)option toValue: (BOOL)value;
-(void)setFixedYears: (id <List>)y;
-(void)setRepeatYears: (id <List>)y;
-(BOOL)reportingForYear: (unsigned)year;

@end
